local M = {}

  local surfaces = {}
  local Scale_1 = 1.0
  local Scale_2 = 1.0
  local Check_1 = 1.0
  local Check_2 = 1.0
local function Rainbow_Mode(COLOR_1, COLOR_2, COLOR_3, Roughness)
  local objID = objID or be:getPlayerVehicleID(0)
  local veh = be:getObjectByID(objID)
  local vd = extensions.core_vehicle_manager.getVehicleData(objID)
  vd.config.paints = vd.config.paints or {}
  local paint = createVehiclePaint({x = COLOR_1 / 1000, y = COLOR_2 / 1000, z = COLOR_3 / 1000, w=2}, {1, Roughness, 0, 0})

  vd.config.paints[1] = paint
  vd.config.paints[2] = paint
  vd.config.paints[3] = paint
  extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 1, paint)
  extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 2, paint)
  extensions.core_vehicle_manager.liveUpdateVehicleColors(objID, veh, 3, paint)
end

local function Drift_Drag_WTF_Mode(Mode)
  if Mode == 0 then Scale_1 = 1.0 Scale_2 = 1.0  Check_1 = 0.69999999 Check_2 = 0.69999997 end
  if Mode == 1 then Scale_1 = 0.5 Scale_2 = 0.5  Check_1 = 0.349999995 Check_2 = 0.349999993 end
  if Mode == 2 then Scale_1 = 2.0 Scale_2 = 3.5  Check_1 = 2.450000048 Check_2 = 2.450000046 end
  if Mode == 3 then Scale_1 = 0.9 Scale_2 = -0.5 Check_1 = -0.349999993 Check_2 = -0.349999995 end

  surfaces["ASPHALT"] = be:getGroundModel("ASPHALT").data
  if surfaces["ASPHALT"]["slidingFrictionCoefficient"] < Check_1 and surfaces["ASPHALT"]["slidingFrictionCoefficient"] > Check_2 then else print(132)
	surfaces["ASPHALT"] = be:getGroundModel("ASPHALT").data surfaces["ASPHALT"]["staticFrictionCoefficient"] = 0.98*Scale_1 surfaces["ASPHALT"]["slidingFrictionCoefficient"] = 0.7*Scale_2 be:setGroundModel("ASPHALT", surfaces["ASPHALT"])
	surfaces["ASPHALT_OLD"] = be:getGroundModel("ASPHALT_OLD").data surfaces["ASPHALT_OLD"]["staticFrictionCoefficient"] = 0.96*Scale_1 surfaces["ASPHALT_OLD"]["slidingFrictionCoefficient"] = 0.67*Scale_2 be:setGroundModel("ASPHALT_OLD", surfaces["ASPHALT_OLD"])
	surfaces["ASPHALT_PREPPED"] = be:getGroundModel("ASPHALT_PREPPED").data surfaces["ASPHALT_PREPPED"]["staticFrictionCoefficient"] = 1.5*Scale_1 surfaces["ASPHALT_PREPPED"]["slidingFrictionCoefficient"] = 1.2*Scale_2 be:setGroundModel("ASPHALT_PREPPED", surfaces["ASPHALT_PREPPED"])
	surfaces["ASPHALT_WET"] = be:getGroundModel("ASPHALT_WET").data surfaces["ASPHALT_WET"]["staticFrictionCoefficient"] = 0.92*Scale_1 surfaces["ASPHALT_WET"]["slidingFrictionCoefficient"] = 0.55*Scale_2 be:setGroundModel("ASPHALT_WET", surfaces["ASPHALT_WET"])
	surfaces["ASPHALT_WET2"] = be:getGroundModel("ASPHALT_WET2").data surfaces["ASPHALT_WET2"]["staticFrictionCoefficient"] = 0.92*Scale_1 surfaces["ASPHALT_WET2"]["slidingFrictionCoefficient"] = 0.55*Scale_2 be:setGroundModel("ASPHALT_WET2", surfaces["ASPHALT_WET2"])
	surfaces["ASPHALT_WET3"] = be:getGroundModel("ASPHALT_WET3").data surfaces["ASPHALT_WET3"]["staticFrictionCoefficient"] = 0.92*Scale_1 surfaces["ASPHALT_WET3"]["slidingFrictionCoefficient"] = 0.55*Scale_2 be:setGroundModel("ASPHALT_WET3", surfaces["ASPHALT_WET3"])
	surfaces["CONCRETE"] = be:getGroundModel("CONCRETE").data surfaces["CONCRETE"]["staticFrictionCoefficient"] = 0.98*Scale_1 surfaces["CONCRETE"]["slidingFrictionCoefficient"] = 0.7*Scale_2 be:setGroundModel("CONCRETE", surfaces["CONCRETE"])
	surfaces["CONCRETE2"] = be:getGroundModel("CONCRETE2").data surfaces["CONCRETE2"]["staticFrictionCoefficient"] = 0.98*Scale_1 surfaces["CONCRETE2"]["slidingFrictionCoefficient"] = 0.7*Scale_2 be:setGroundModel("CONCRETE2", surfaces["CONCRETE2"])
	surfaces["GRID"] = be:getGroundModel("GRID").data surfaces["GRID"]["staticFrictionCoefficient"] = 0.98*Scale_1 surfaces["GRID"]["slidingFrictionCoefficient"] = 0.7*Scale_2 be:setGroundModel("GRID", surfaces["GRID"])
	surfaces["GROUNDMODEL_ASPHALT1"] = be:getGroundModel("GROUNDMODEL_ASPHALT1").data surfaces["GROUNDMODEL_ASPHALT1"]["staticFrictionCoefficient"] = 0.98*Scale_1 surfaces["GROUNDMODEL_ASPHALT1"]["slidingFrictionCoefficient"] = 0.7*Scale_2 be:setGroundModel("GROUNDMODEL_ASPHALT1", surfaces["GROUNDMODEL_ASPHALT1"])
	surfaces["GROUNDMODEL_ASPHALT_OLD"] = be:getGroundModel("GROUNDMODEL_ASPHALT_OLD").data surfaces["GROUNDMODEL_ASPHALT_OLD"]["staticFrictionCoefficient"] = 0.96*Scale_1 surfaces["GROUNDMODEL_ASPHALT_OLD"]["slidingFrictionCoefficient"] = 0.67*Scale_2 be:setGroundModel("GROUNDMODEL_ASPHALT_OLD", surfaces["GROUNDMODEL_ASPHALT_OLD"])
	surfaces["SLIPPERY"] = be:getGroundModel("SLIPPERY").data surfaces["SLIPPERY"]["staticFrictionCoefficient"] = 0.6*Scale_1 surfaces["SLIPPERY"]["slidingFrictionCoefficient"] = 0.2*Scale_2 be:setGroundModel("SLIPPERY", surfaces["SLIPPERY"])
  end
end

local function reload()
reloadUI()
be:reloadVehicle(0)
end

M.Rainbow_Mode = Rainbow_Mode
M.Drift_Drag_WTF_Mode = Drift_Drag_WTF_Mode
M.reload = reload
return M
