angular.module('beamng.apps')
.directive('cheatPanel', [function () {
  return {
	templateUrl: '/ui/modules/apps/cheatPanel/app.html',
	replace: true,

  link: function (scope, element, attrs) {
	clearInterval(Time_Interval);
	clearInterval(Time_Interval_2);
	scope.ON_OFF_RAINBOW = false;
	scope.Roughness = 0.25;
	scope.ON_OFF_DRIFT = false;
	scope.ON_OFF_DRAG = false;
	scope.ON_OFF_WTF = false;
	scope.ON_OFF_GM_ENGINE = false;
	scope.ON_OFF_MORE_POWER = false;
	scope.ON_OFF_MORE_POWER_SMOOTH = false;
	scope.Multiplier = 1.0;
	var ON_OFF_SMOOTH_MODE = 0;
	var RAINBOW_TEXT_R = 1000;
	var RAINBOW_TEXT_G = 0;
	var RAINBOW_TEXT_B = 0;
	var GameVersions = Number(beamng.versionshort.substr(2,4));
	if (GameVersions > 23.5) {
		Update();
		return
	};

	var Time_Interval = setInterval( () => {
		if (scope.ON_OFF_RAINBOW == true) {
			if (RAINBOW_TEXT_R == 1000 && RAINBOW_TEXT_G < 1000  && RAINBOW_TEXT_B == 0000) { RAINBOW_TEXT_G = RAINBOW_TEXT_G + 10} else { RAINBOW_TEXT_G = RAINBOW_TEXT_G};
			if (RAINBOW_TEXT_R > 0000  && RAINBOW_TEXT_G == 1000 && RAINBOW_TEXT_B == 0000) { RAINBOW_TEXT_R = RAINBOW_TEXT_R - 10} else { RAINBOW_TEXT_R = RAINBOW_TEXT_R};
			if (RAINBOW_TEXT_R == 0000 && RAINBOW_TEXT_G == 1000 && RAINBOW_TEXT_B <  1000) { RAINBOW_TEXT_B = RAINBOW_TEXT_B + 10} else { RAINBOW_TEXT_B = RAINBOW_TEXT_B};
			if (RAINBOW_TEXT_R == 0000 && RAINBOW_TEXT_G > 0000  && RAINBOW_TEXT_B == 1000) { RAINBOW_TEXT_G = RAINBOW_TEXT_G - 10} else { RAINBOW_TEXT_G = RAINBOW_TEXT_G};
			if (RAINBOW_TEXT_R < 1000  && RAINBOW_TEXT_G == 0000 && RAINBOW_TEXT_B == 1000) { RAINBOW_TEXT_R = RAINBOW_TEXT_R + 10} else { RAINBOW_TEXT_R = RAINBOW_TEXT_R};
			if (RAINBOW_TEXT_R == 1000 && RAINBOW_TEXT_G == 0000 && RAINBOW_TEXT_B >  0000) { RAINBOW_TEXT_B = RAINBOW_TEXT_B - 10} else { RAINBOW_TEXT_B = RAINBOW_TEXT_B};
			bngApi.engineLua('scripts_cheatPanel_extension.Rainbow_Mode(' + RAINBOW_TEXT_R + ',' + RAINBOW_TEXT_G + ',' + RAINBOW_TEXT_B + ',' + scope.Roughness + ')');
			document.getElementById('CHEAT_PANEL').style.color = 'rgba(' + RAINBOW_TEXT_R * 0.255 + ',' + RAINBOW_TEXT_G * 0.255 + ',' + RAINBOW_TEXT_B * 0.255 + ',1.0)';
		};
	}, 8);

	var Time_Interval_2 = setInterval( () => {
		//дрифт/драг/втф
		if (scope.ON_OFF_DRAG == false && scope.ON_OFF_DRIFT == false && scope.ON_OFF_WTF == false) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')')
		};

		if (scope.ON_OFF_DRIFT == true && scope.ON_OFF_DRAG == true && scope.ON_OFF_WTF == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')');
			scope.ON_OFF_DRIFT = false;
			scope.ON_OFF_DRAG = false;
			scope.ON_OFF_WTF = false
		};

		if (scope.ON_OFF_DRIFT == true && scope.ON_OFF_DRAG == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')');
			scope.ON_OFF_DRIFT = false;
			scope.ON_OFF_DRAG = false
		};

		if (scope.ON_OFF_DRIFT == true && scope.ON_OFF_WTF == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')');
			scope.ON_OFF_DRIFT = false;
			scope.ON_OFF_WTF = false
		};

		if (scope.ON_OFF_WTF == true && scope.ON_OFF_DRAG == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 0 + ')');
			scope.ON_OFF_WTF = false;
			scope.ON_OFF_DRAG = false
		};

		if (scope.ON_OFF_DRIFT == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 1 + ')')
		};

		if (scope.ON_OFF_DRAG == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 2 + ')')
		};

		if (scope.ON_OFF_WTF == true) {
			bngApi.engineLua('scripts_cheatPanel_extension.Drift_Drag_WTF_Mode(' + 3 + ')');
		};

		//моторная часть
		if (scope.ON_OFF_MORE_POWER_SMOOTH == false) {
			ON_OFF_SMOOTH_MODE = 0
		};

		if (scope.ON_OFF_MORE_POWER_SMOOTH == true) {
			ON_OFF_SMOOTH_MODE = 1
		};

		if (scope.ON_OFF_GM_ENGINE == false && scope.ON_OFF_MORE_POWER == true) {
			scope.ON_OFF_GM_ENGINE = true
		};

		if (scope.ON_OFF_GM_ENGINE == false) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_GM_ENGINE(' + 0 + ')')
		};

		if (scope.ON_OFF_GM_ENGINE == true) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_GM_ENGINE(' + 1 + ')')
		};

		if (scope.ON_OFF_MORE_POWER == false) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_MORE_POWER(' + 0 + ',' + ON_OFF_SMOOTH_MODE + ',' + scope.Multiplier + ')')
		};

		if (scope.ON_OFF_MORE_POWER == true) {
			bngApi.activeObjectLua('extensions.cheatPanel.ON_OFF_MORE_POWER(' + 1 + ',' + ON_OFF_SMOOTH_MODE + ',' + scope.Multiplier + ')')
		};

		//тест языка
		var lang = vueI18n.global.locale;
		if (lang == 'ru_RU') {
			if (document.getElementById('Author').innerHTML == 'By Ns Pro') {} else {
				document.getElementById('ON_OFF_RAINBOW').innerHTML = 'Включение режима радуги';
				document.getElementById('Roughness').innerHTML = 'Шероховатость';
				document.getElementById('Roughness').style.fontSize='11px';
				document.getElementById('Roughness').style.marginTop ='17px';

				document.getElementById('ON_OFF_DRIFT').innerHTML = 'Включение дрифт режима';
				document.getElementById('ON_OFF_DRAG').innerHTML = 'Включение драг режима';
				document.getElementById('ON_OFF_WTF').innerHTML = 'Включение WTF режима';

				document.getElementById('ON_OFF_GM_ENGINE').innerHTML = 'Неразрушаемый двигатель';
				document.getElementById('Reload').innerHTML = 'Перезагрузка';
				document.getElementById('Reload').style.marginLeft = '208px';
				document.getElementById('Reload').style.marginTop = '-19px';
				document.getElementById('Reload').style.fontSize = '13px';
				document.getElementById('Reload_button').style.minWidth = '83px';
				document.getElementById('Reload_button').style.Width = '83px';
				document.getElementById('Reload_button').style.maxWidth = '83px';
				document.getElementById('Reload_button').style.marginLeft = '208px';
				document.getElementById('ON_OFF_MORE_POWER_checkbox').style.marginTop = '13px';
				document.getElementById('ON_OFF_MORE_POWER').innerHTML = 'БОЛЬШЕ МОЩИ!!!';
				document.getElementById('ON_OFF_MORE_POWER_SMOOTH').innerHTML = 'Плавно';
				document.getElementById('Multiplier').innerHTML = 'Множитель для множителя 🙂';
				document.getElementById('Author').innerHTML = 'By Ns Pro';
			};
		};
	}, 1000);

	function Update () {
		let text_upd
		var lang = vueI18n.global.locale;
		if (lang == 'ru_RU') {text_upd = 'Обновите мод'} else {text_upd = 'Please update mod'}
		document.getElementById('CHEAT_PANEL').innerHTML = text_upd;
		document.getElementById('ON_OFF_RAINBOW').innerHTML = text_upd;
		document.getElementById('Roughness').innerHTML = text_upd;
		document.getElementById('ON_OFF_DRIFT').innerHTML = text_upd;
		document.getElementById('ON_OFF_DRAG').innerHTML = text_upd;
		document.getElementById('ON_OFF_WTF').innerHTML = text_upd;
		document.getElementById('ON_OFF_GM_ENGINE').innerHTML = text_upd;
		document.getElementById('Reload').innerHTML = text_upd;
		document.getElementById('ON_OFF_MORE_POWER').innerHTML = text_upd;
		document.getElementById('ON_OFF_MORE_POWER_SMOOTH').innerHTML = text_upd;
		document.getElementById('Multiplier').innerHTML = text_upd;
	};
	scope.$on('$destroy', () => {
		scope.ON_OFF_RAINBOW = false;
		scope.Roughness = 0.25;
		scope.ON_OFF_DRIFT = false;
		scope.ON_OFF_DRAG = false;
		scope.ON_OFF_WTF = false;
		scope.ON_OFF_GM_ENGINE = false;
		scope.ON_OFF_MORE_POWER = false;
		scope.ON_OFF_MORE_POWER_SMOOTH = false;
		scope.Multiplier = 1.0
		var ON_OFF_SMOOTH_MODE = 0;
		var RAINBOW_TEXT_R = 1000;
		var RAINBOW_TEXT_G = 0;
		var RAINBOW_TEXT_B = 0;
		clearInterval(Time_Interval);
		clearInterval(Time_Interval_2)
	});
	scope.Reload = function () {bngApi.engineLua('scripts_cheatPanel_extension.reload()')}
	}}}]);